import { TNSDOMMatrix } from './TNSDOMMatrix';
import { TNSCanvasBase } from './canvas-plugin.common';
import { TNSCanvasRenderingContext2D } from './TNSCanvasRenderingContext2D';
import { TNSWebGLRenderingContext } from './TNSWebGLRenderingContext';
import { TNSWebGL2RenderingContext } from './TNSWebGL2RenderingContext';
export declare function createSVGMatrix(): TNSDOMMatrix;
export * from './canvas-plugin.common';
export declare class TNSCanvas extends TNSCanvasBase {
    useMetal: boolean;
    private _2dContext;
    private _webglContext;
    private _webgl2Context;
    private _canvas;
    private _didPause;
    private _isReady;
    constructor();
    get ios(): any;
    get clientWidth(): number;
    get clientHeight(): number;
    get width(): number;
    set width(value: number);
    get height(): number;
    set height(value: number);
    private _iosOverflowSafeArea;
    get iosOverflowSafeArea(): boolean;
    set iosOverflowSafeArea(value: boolean);
    static createCustomView(): TNSCanvas;
    createNativeView(): any;
    flush(): void;
    onUnloaded(): void;
    onLoaded(): void;
    onLayout(left: number, top: number, right: number, bottom: number): void;
    disposeNativeView(): void;
    _layoutNative(): void;
    getContext(type: string, options?: any): TNSCanvasRenderingContext2D | TNSWebGLRenderingContext | TNSWebGL2RenderingContext | null;
    toDataURL(type?: string, encoderOptions?: number): any;
    getBoundingClientRect(): {
        x: number;
        y: number;
        width: number;
        height: number;
        top: number;
        right: number;
        bottom: number;
        left: number;
    };
}
