"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var view_1 = require("@nativescript/core/ui/core/view");
var TNSPath2D_1 = require("../TNSPath2D");
var SVGItem_1 = require("./SVGItem");
exports.cxProperty = new view_1.Property({
    name: 'cx'
});
exports.cyProperty = new view_1.Property({
    name: 'cy'
});
exports.rxProperty = new view_1.Property({
    name: 'rx'
});
exports.ryProperty = new view_1.Property({
    name: 'ry'
});
var Ellipse = (function (_super) {
    __extends(Ellipse, _super);
    function Ellipse() {
        var _this = _super.call(this) || this;
        _this.stroke = 'transparent';
        return _this;
    }
    Ellipse.prototype.handleValues = function (canvas) {
        var ctx;
        if (canvas) {
            ctx = canvas.getContext('2d');
        }
        else {
            ctx = this._canvas.getContext('2d');
        }
        var ellipse = new TNSPath2D_1.TNSPath2D();
        ellipse.ellipse(this.cx, this.cy, this.rx, this.ry, 0, 0, 2 * Math.PI);
        ctx.save();
        if (this._doFill()) {
            ctx.fillStyle = this._realFill;
            ctx.stroke(ellipse);
        }
        if (this._doStroke()) {
            ctx.strokeStyle = this._realStroke;
            ctx.fill(ellipse);
        }
        ctx.restore();
    };
    return Ellipse;
}(SVGItem_1.SVGItem));
exports.Ellipse = Ellipse;
exports.cxProperty.register(Ellipse);
exports.cyProperty.register(Ellipse);
exports.rxProperty.register(Ellipse);
exports.ryProperty.register(Ellipse);
//# sourceMappingURL=Ellipse.js.map