"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var SVGItem_1 = require("./SVGItem");
var G = (function (_super) {
    __extends(G, _super);
    function G() {
        var _this = _super.call(this) || this;
        _this._views = [];
        return _this;
    }
    G.prototype._addChildFromBuilder = function (name, value) {
        value._canvas = this._canvas;
        value.parent = this;
        this._views.push(value);
        this._appendChild(value.id || value._domId, value);
    };
    G.prototype.handleValues = function () {
        var _this = this;
        var ctx = this._canvas.getContext('2d');
        ctx.save();
        if (typeof this.transform === 'string') {
            var matrix = this.transform.replace('matrix(', '')
                .replace('(', '')
                .split(',')
                .map(function (value) {
                var val = parseFloat(value);
                if (isNaN(val)) {
                    return 0;
                }
                return val;
            });
            ctx.transform(matrix[0], matrix[1], matrix[2], matrix[3], matrix[4], matrix[5]);
        }
        var updateColors = function () {
            if (_this._doStroke()) {
                ctx.strokeStyle = _this.stroke;
            }
            if (_this._doFill()) {
                if (_this.fill === undefined) {
                    ctx.fillStyle = 'black';
                }
                else {
                    ctx.fillStyle = _this.fill;
                }
            }
        };
        this._views.forEach(function (view) {
            if (typeof view.handleValues === 'function') {
                updateColors();
                ctx.globalAlpha = _this.opacity;
                view.handleValues();
            }
            else if (view instanceof G) {
                view._views.forEach(function (view) {
                    updateColors();
                    view.handleValues();
                });
            }
        });
        ctx.restore();
    };
    return G;
}(SVGItem_1.SVGItem));
exports.G = G;
//# sourceMappingURL=G.js.map