"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var view_1 = require("@nativescript/core/ui/core/view");
var TNSPath2D_1 = require("../TNSPath2D");
var SVGItem_1 = require("./SVGItem");
exports.x1Property = new view_1.Property({
    name: 'x1'
});
exports.y1Property = new view_1.Property({
    name: 'y1'
});
exports.x2Property = new view_1.Property({
    name: 'x2'
});
exports.y2Property = new view_1.Property({
    name: 'y2'
});
var Line = (function (_super) {
    __extends(Line, _super);
    function Line() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Line.prototype.handleValues = function (canvas) {
        var ctx;
        if (canvas) {
            ctx = canvas.getContext('2d');
        }
        else {
            ctx = this._canvas.getContext('2d');
        }
        var line = new TNSPath2D_1.TNSPath2D();
        line.moveTo(this.x1, this.y1);
        line.lineTo(this.x2, this.y2);
        ctx.save();
        ctx.lineWidth = this.strokeWidth;
        if (this._doStroke()) {
            ctx.strokeStyle = this._realStroke;
            ctx.fill(line);
        }
        ctx.restore();
    };
    return Line;
}(SVGItem_1.SVGItem));
exports.Line = Line;
exports.x1Property.register(Line);
exports.x2Property.register(Line);
exports.y1Property.register(Line);
exports.y2Property.register(Line);
//# sourceMappingURL=Line.js.map