"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var SVGItem_1 = require("./SVGItem");
var SVG_1 = require("./SVG");
var Stop_1 = require("./Stop");
var LinearGradient = (function (_super) {
    __extends(LinearGradient, _super);
    function LinearGradient() {
        var _this = _super.call(this) || this;
        _this.x1 = '0%';
        _this.y1 = '0%';
        _this.x2 = '100%';
        _this.y2 = '0%';
        _this._views = [];
        return _this;
    }
    LinearGradient.prototype._getFillOrStrokeStyle = function (canvas) {
        var ctx;
        if (canvas) {
            ctx = canvas.getContext('2d');
        }
        else {
            ctx = this._canvas.getContext('2d');
        }
        var svg = this.parent;
        while (!(svg instanceof SVG_1.SVG)) {
            svg = svg.parent;
            if (svg === undefined || svg === null) {
                break;
            }
        }
        var height = svg ? svg.getMeasuredHeight() : 0;
        var width = svg ? svg.getMeasuredWidth() : 0;
        var realX1 = this._getRealSize(this.x1, width);
        var realX2 = this._getRealSize(this.x2, width);
        var realY1 = this._getRealSize(this.y1, height);
        var realY2 = this._getRealSize(this.y2, height);
        var gradient = ctx.createLinearGradient(realX1, realY1, realX2, realY2);
        this._views.forEach(function (child) {
            if (child instanceof Stop_1.Stop) {
                var offset = child._realOffset();
                gradient.addColorStop(offset, child.stopColor);
            }
        });
        return gradient;
    };
    LinearGradient.prototype._addChildFromBuilder = function (name, value) {
        value._canvas = this._canvas;
        value.parent = this;
        this._views.push(value);
        this._appendChild(value.id || value._domId, value);
    };
    return LinearGradient;
}(SVGItem_1.SVGItem));
exports.LinearGradient = LinearGradient;
//# sourceMappingURL=LinearGradient.js.map