"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var SVGItem_1 = require("./SVGItem");
var TNSCanvas_1 = require("../TNSCanvas");
var view_1 = require("@nativescript/core/ui/core/view");
var SVG_1 = require("./SVG");
var Pattern = (function (_super) {
    __extends(Pattern, _super);
    function Pattern() {
        var _this = _super.call(this) || this;
        _this._pattern = new TNSCanvas_1.TNSCanvas();
        _this._views = [];
        return _this;
    }
    Object.defineProperty(Pattern.prototype, "width", {
        get: function () {
            return this.style.width;
        },
        set: function (value) {
            this._pattern.width = value;
            this.style.width = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Pattern.prototype, "height", {
        get: function () {
            return this.style.height;
        },
        set: function (value) {
            this._pattern.height = value;
            this.style.height = value;
        },
        enumerable: true,
        configurable: true
    });
    Pattern.prototype._addChildFromBuilder = function (name, value) {
        value.parent = this;
        value._canvas = this._canvas;
        this._views.push(value);
        this._appendChild(value.id || value._domId, value);
    };
    Pattern.prototype._getFillOrStrokeStyle = function () {
        var canvas = new TNSCanvas_1.TNSCanvas();
        canvas._isCustom = true;
        var svg = this.parent;
        while (!(svg instanceof SVG_1.SVG)) {
            svg = svg.parent;
        }
        var height = svg.getMeasuredHeight() || 0;
        var width = svg.getMeasuredWidth() || 0;
        var w;
        var h;
        if (this.width && this.width.unit === '%') {
            w = view_1.PercentLength.convertToString(this.width);
        }
        if (this.height && this.height.unit === '%') {
            h = view_1.PercentLength.convertToString(this.height);
        }
        if (typeof this.width === 'string') {
            w = this.width;
        }
        if (typeof this.height === 'string') {
            h = this.height;
        }
        if (typeof this.width === 'number') {
            w = this.width;
        }
        if (typeof this.height === 'number') {
            h = this.height;
        }
        if (typeof w === 'string' && (w.indexOf('%') > -1)) {
            canvas.width = (width * (parseInt(w.replace('%', '')) / 100));
        }
        else if (typeof w === 'number') {
            canvas.width = w;
        }
        if (typeof h === 'string' && (h.indexOf('%') > -1)) {
            canvas.height = (height * (parseInt(h.replace('%', '')) / 100));
        }
        else if (typeof this.height === 'number') {
            canvas.height = this.height;
        }
        this._views.forEach(function (view) {
            view.handleValues(canvas);
        });
        return canvas;
    };
    return Pattern;
}(SVGItem_1.SVGItem));
exports.Pattern = Pattern;
//# sourceMappingURL=Pattern.js.map