"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var SVGItem_1 = require("./SVGItem");
var CanvasGradient_1 = require("../CanvasGradient");
var Rect = (function (_super) {
    __extends(Rect, _super);
    function Rect() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.x = 0;
        _this.y = 0;
        _this.rx = 0;
        _this.ry = 0;
        return _this;
    }
    Rect.prototype.handleValues = function (canvas) {
        var ctx;
        if (canvas) {
            ctx = canvas.getContext('2d');
        }
        else {
            ctx = this._canvas.getContext('2d');
        }
        ctx.save();
        ctx.globalAlpha = this._realOpacity;
        var lastOpacity;
        if (this._doFillOpacity()) {
            lastOpacity = ctx.globalAlpha;
            ctx.globalAlpha = this._realFillOpacity;
        }
        if (this._doFill()) {
            if (this.fill !== undefined && this.fill !== 'none') {
                if (this.fill && this.fill.indexOf('url') > -1) {
                    var fill = this._getViewById(this.fill);
                    if (fill) {
                        var style = fill._getFillOrStrokeStyle();
                        if (style instanceof CanvasGradient_1.CanvasGradient) {
                            ctx.fillStyle = style;
                        }
                        else {
                            ctx.fillStyle = ctx.createPattern(style, 'repeat');
                        }
                    }
                }
                else {
                    ctx.fillStyle = this.fill;
                }
            }
            ctx.fillRect(this.x, this.y, this._getRealSize(this.width, null, 'width'), this._getRealSize(this.height, null, 'height'));
        }
        if (lastOpacity !== undefined) {
            ctx.globalAlpha = lastOpacity;
        }
        if (this._doStroke()) {
            if (this.stroke !== undefined && this.stroke !== 'none') {
                if (this.stroke && this.stroke.indexOf('url') > -1) {
                    var stroke = this._getViewById(this.stroke);
                    var style = stroke._getFillOrStrokeStyle();
                    if (style instanceof CanvasGradient_1.CanvasGradient) {
                        ctx.strokeStyle = style;
                    }
                    else if (stroke) {
                        ctx.strokeStyle = ctx.createPattern(style, 'repeat');
                    }
                }
                else {
                    ctx.strokeStyle = this.stroke;
                }
            }
            ctx.strokeRect(this.x, this.y, this._getRealSize(this.width, null, 'width'), this._getRealSize(this.height, null, 'height'));
        }
        ctx.restore();
    };
    return Rect;
}(SVGItem_1.SVGItem));
exports.Rect = Rect;
//# sourceMappingURL=Rect.js.map