"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var view_1 = require("@nativescript/core/ui/core/view");
var TNSCanvas_1 = require("../TNSCanvas");
var xmldom_qsa_1 = require("xmldom-qsa");
exports.strokeProperty = new view_1.CssProperty({
    name: 'stroke',
    cssName: 'stroke',
    defaultValue: undefined
});
exports.strokeWidthProperty = new view_1.CssProperty({
    name: 'strokeWidth',
    cssName: 'stroke-width',
    defaultValue: 1,
});
exports.fillProperty = new view_1.CssProperty({
    name: 'fill',
    cssName: 'fill',
    defaultValue: undefined
});
exports.fillOpacityProperty = new view_1.CssProperty({
    name: 'fillOpacity',
    cssName: 'fill-opacity',
    defaultValue: undefined
});
exports.stopColorProperty = new view_1.CssProperty({
    name: 'stopColor',
    cssName: 'stop-color',
    defaultValue: undefined
});
var SVG = (function (_super) {
    __extends(SVG, _super);
    function SVG() {
        var _this = _super.call(this) || this;
        _this._canvas = new TNSCanvas_1.TNSCanvas();
        _this._views = [];
        _this._parser = new xmldom_qsa_1.DOMParser();
        _this._children = new Map();
        return _this;
    }
    SVG.prototype.createNativeView = function () {
        var _this = this;
        this.on('layoutChanged', function (args) {
            _this._views.forEach(function (view) {
                if (typeof view.handleValues === 'function') {
                    view.handleValues();
                }
            });
        });
        if (this._canvas.ios) {
            return this._canvas.ios;
        }
        return this._canvas.android;
    };
    SVG.prototype._addChildFromBuilder = function (name, value) {
        value._canvas = this._canvas;
        value.parent = this;
        this._views.push(value);
        this._children.set(value.id || value._domId, value);
    };
    SVG.prototype._getViewById = function (name) {
        if (typeof name === 'string') {
            if (name.indexOf('url') > -1) {
                name = name.replace('url', '').replace('(', '').replace(')', '');
            }
            if (name.indexOf('#')) {
                name = name.replace('#', '');
            }
            if (name.startsWith("'")) {
                name = name.replace("'", '').replace("'", '');
            }
            return this._children.get(name);
        }
        return null;
    };
    return SVG;
}(view_1.View));
exports.SVG = SVG;
exports.stopColorProperty.register(view_1.Style);
exports.strokeWidthProperty.register(view_1.Style);
exports.strokeProperty.register(view_1.Style);
exports.fillProperty.register(view_1.Style);
exports.fillOpacityProperty.register(view_1.Style);
//# sourceMappingURL=SVG.js.map